option title, "Windows Shortcut (.lnk) file structure"
=
=
=	Tiny Hexer script for .lnk file structure view in
=	mirkes.de's tiny hex editor
=
=	(C) markus stephany, tinyhexer[at]mirkes[dot]de
=
=	most stuff derived from the document "The Windows Shortcut File Format"
=	by jesse hager jessehager[at]iname[dot]com found on http://www.wotsit.org
=
INCLUDE 'def.mps'

option GlobalVars, 1
option ReadTags, 1
option target, structureviewer

var IsUnicode byte

= HEX() with 0x prefix
local myhex
  var t byte res text
  res = '0x'
  t = typeofstack
  ifgoto t CHAR_DATA _1 BYTE_DATA _2 WORD_DATA _3 LONGWORD_DATA _4 SIGNED_QWORD_DATA _5 TEXT_DATA _6 FILE_DATA _7 VARREF_DATA _8
  ifgoto t SIGNED_BYTE_DATA _13 SIGNED_WORD_DATA _14 SIGNED_LONGWORD_DATA _15
  var t_s extended
  pop t_s
  concat res, hex(t_s,1)
  copytags res t_s
  return res
@@_1
  var t_1 char
  pop t_1
  concat res, hex(t_1,1)
  copytags res t_1
  return res
@@_2
  var t_2 byte
  pop t_2
  concat res, hex(t_2,1)
  copytags res t_2
  return res
@@_3
  var t_3 word
  pop t_3
  concat res, hex(t_3,1)
  copytags res t_3
  return res
@@_4
  var t_4 longword
  pop t_4
  concat res, hex(t_4,1)
  copytags res t_4
  return res
@@_5
  var t_5 qword
  pop t_5
  concat res, hex(t_5,1)
  copytags res t_5
  return res
@@_6
  var t_6 text
  pop t_6
  concat res, hex(t_6,1)
  copytags res t_6
  return res
@@_7
  var t_7 file
  pop t_7
  concat res, hex(t_7,1)
  copytags res t_7
  return res
@@_8
  var t_8 varref
  pop t_8
  concat res, hex(t_8,1)
  copytags res t_8
  return res
@@_13
  var t_13 sigbyte
  pop t_13
  concat res, hex(t_13,1)
  copytags res t_13
  return res
@@_14
  var t_14 sigword
  pop t_14
  concat res, hex(t_14,1)
  copytags res t_14
  return res
@@_15
  var t_15 siglongword
  pop t_15
  concat res, hex(t_15,1)
  copytags res t_15
  return res
endlocal


= get show window value
local getshowwnd
  var i dword res text
  pop i
  ifgoto i 0 _0 1 _1 2 _2 3 _3 4 _4 5 _5 6 _6 7 _7 8 _8 9 _9 10 _10
  return #myhex(i)
@@_0 : res ="SW_HIDE (0x00)": copytags res i:return res
@@_1 : res = 'SW_SHOWNORMAL (0x01)': copytags res i:return res
@@_2 : res = 'SW_SHOWMINIMIZED (0x02)': copytags res i:return res
@@_3 : res = 'SW_SHOWMAXIMIZED (0x03)': copytags res i:return res
@@_4 : res = 'SW_SHOWNOACTIVATE (0x04)': copytags res i:return res
@@_5 : res = 'SW_SHOW (0x05)': copytags res i:return res
@@_6 : res = 'SW_MINIMIZE (0x06)': copytags res i:return res
@@_7 : res = 'SW_SHOWMINNOACTIVE (0x07)': copytags res i:return res
@@_8 : res = 'SW_SHOWNA (0x08)': copytags res i:return res
@@_9 : res = 'SW_RESTORE (0x09)': copytags res i:return res
@@_10: res = 'SW_SHOWDEFAULT (0x0a)': copytags res i:return res
endlocal

= get local volume type
local getlocalvoltype
  var i dword res text
  pop i
  ifgoto i 0 _0 1 _1 2 _2 3 _3 4 _4 5 _5 6 _6
  return #myhex(i)
@@_0 : res ="DRIVE_UNKNOWN (0x00)": copytags res i:return res
@@_1 : res = 'DRIVE_NO_ROOT_DIR (0x01)': copytags res i:return res
@@_2 : res = 'DRIVE_REMOVABLE (0x02)': copytags res i:return res
@@_3 : res = 'DRIVE_FIXED (0x03)': copytags res i:return res
@@_4 : res = 'DRIVE_REMOTE (0x04)': copytags res i:return res
@@_5 : res = 'DRIVE_CDROM (0x05)': copytags res i:return res
@@_6 : res = 'DRIVE_RAMDISK (0x06)': copytags res i:return res
endlocal


= convert a local to an utc filetime
DLLFUNC LocalFileTimeToFileTime kernel32.dll out DWORD in @QWORD @QWORD

= convert an utc to a local filetime
DLLFUNC FileTimeToLocalFileTime kernel32.dll out DWORD in @QWORD @QWORD

= convert a filetime to a systemtime
DLLFUNC FileTimeToSystemTime kernel32.dll out DWORD in @QWORD @TEXT[16]

= convert an systemtime to a filetime
DLLFUNC SystemTimeToFileTime kernel32.dll out DWORD in TEXT[16] @QWORD


= convert a systemtime to a time format
DLLFUNC GetTimeFormat kernel32.dll name GetTimeFormatA in DWORD DWORD TEXT[16] TEXT @TEXT SIGLONGWORD out SIGLONGWORD

= convert a systemtime to a date format
DLLFUNC GetDateFormat kernel32.dll name GetDateFormatA in DWORD DWORD TEXT[16] TEXT @TEXT SIGLONGWORD out SIGLONGWORD

local systemtimetostring:= convert a systeme time to a date/time string
  = params in systemtime (text[16]) out text
  var in text out text temp text nil none len siglongword
  pop in
  temp = (Char(0)+Char(0)) * 128:= prepare a buffer
  len = GetDateFormat(1 << 10 ,0, in, nil, @temp, 256)
  out = textchop(textcopy(temp, 1, len))+' '
  temp = (Char(0)+Char(0)) * 128:= prepare a buffer
  len = GetTimeFormat(1 << 10 ,0, in, nil, @temp, 256)
  concat out textchop(textcopy(temp, 1, len))
  return out
endlocal

= function to convert a file time to a readable text
local FileTimeToString
  var ft QWORD st TEXT ft1 QWORD
  pop ft
  FileTimeToLocalFileTime(@ft, @ft1)
  FileTimeToSystemTime(@ft1, @st)
  return #SystemTimeToString(st)
endlocal



= function to create a guid string
local hexbyte
  var s text p byte
  pop p
  pop s
  return HEX(TEXT2DATA(s, p-1, -BYTE_DATA))
endlocal

local createguidstr 
  var guidin text guidout text
  pop guidin
  if (textlen(guidin) != 16)
    error "Invalid GUID"
  endif
  guidout = '{'+#Hexbyte(guidin,0x04)+#Hexbyte(guidin,0x03)+#Hexbyte(guidin,0x02)+#Hexbyte(guidin,0x01)
  concat guidout, '-'+#Hexbyte(guidin,0x06)+#Hexbyte(guidin,0x05)+'-'+#Hexbyte(guidin,0x08)+#Hexbyte(guidin,0x07)
  concat guidout, '-'+#Hexbyte(guidin,0x09)+#Hexbyte(guidin,0x0a)
  concat guidout, '-'+#Hexbyte(guidin,0x0b)+#Hexbyte(guidin,0x0c)+#Hexbyte(guidin,0x0d)+#Hexbyte(guidin,0x0e)+#Hexbyte(guidin,0x0f)+#Hexbyte(guidin,0x10)+'}'
  copytags guidout guidin
  return guidout
endlocal

= open active editor and goto current position/0
var editor file




= read a string prefixed by a word length field
local myreadstring
  var len word res text p dword
  p = filepos(editor)
  fileread editor len
  if IsUnicode
    fileread editor res len*2
    res = textconvert(res, TEXTCONVERT_UNICODE, TEXTCONVERT_ANSI)
    tagvar res p len*2+2
  else
    fileread editor res len
    tagvar res p len+2
  endif
  return res
endlocal






editor = fileopen('::current')
if ((param_count > 0) and (dword(params(0))==1))
  fileseek editor, 0
else
  fileseek editor, filegetprop(editor, 'selstart')
endif
var start dword
start = filegetprop(editor, 'position')

= open browser window
var browser file
browser = fileopen('::browser', 'c')

filesetprop browser, 'accepttags', 1
filewrite browser "<font color=",'"',"blue",'"',"><b><u>Windows Shortcut file structure:</u></b></font>\n\n"
filesetprop browser, 'accepttags', 0

filewrite browser "File: '",filegetprop(editor, 'filename'),"'\nPosition: ",start,"\n\n"

= read the file header
var H_Sig DWORD H_Guid TEXT H_Flags DWORD
var H_Attr DWORD H_Create QWORD H_Modified QWORD H_LastAccess QWORD
var H_FileLen DWORD H_IconIndex DWORD H_ShowWnd DWORD H_HotKey DWORD H_Stuff QWORD

fileread editor H_Sig
if (H_sig != 0x4c)
  error "Unknown file signature: ", #myhex(H_Sig)
endif
filewrite browser "-- Header --\nSignature:\t", #myhex(H_Sig), " ('L')\n"

var temp text
fileread editor H_Guid 16
temp = #createguidstr(H_Guid)
filewrite browser "GUID:\t\t",temp ,"\n"

fileread editor H_Flags
filewrite browser "\nFlags:\t\t", #myhex(H_Flags),"\n"
if (H_Flags and 1)
  filewrite browser "\t\tLNK contains shell item id list (0x01)\n"
endif
if (H_Flags and 2)
  filewrite browser "\t\tLNK points to file or directory (0x02)\n"
endif
if (H_Flags and 4)
  filewrite browser "\t\tLNK contains description (0x04)\n"
endif
if (H_Flags and 8)
  filewrite browser "\t\tLNK contains a relative path string (0x08)\n"
endif
if (H_Flags and 16)
  filewrite browser "\t\tLNK contains a working path (0x10)\n"
endif
if (H_Flags and 32)
  filewrite browser "\t\tLNK contains command line arguments (0x20)\n"
endif
if (H_Flags and 64)
  filewrite browser "\t\tLNK contains a custom icon (0x40)\n"
endif
if (H_Flags and 128)
  filewrite browser "\t\tLNK contains unicode filenames (0x80)\n"
  IsUnicode = 1
endif

fileread editor H_Attr
filewrite browser "\nFile Attr.:\t", #myhex(H_Attr),"\n"
if (H_Attr and 1)
  filewrite browser "\t\tFILE_ATTRIBUTE_READONLY (0x01)\n"
endif
if (H_Attr and 2)
  filewrite browser "\t\tFILE_ATTRIBUTE_HIDDEN (0x02)\n"
endif
if (H_Attr and 4)
  filewrite browser "\t\tFILE_ATTRIBUTE_SYSTEM (0x04)\n"
endif
if (H_Attr and 0x10)
  filewrite browser "\t\tFILE_ATTRIBUTE_DIRECTORY (0x10)\n"
endif
if (H_Attr and 0x20)
  filewrite browser "\t\tFILE_ATTRIBUTE_ARCHIVE (0x20)\n"
endif
if (H_Attr and 0x40)
  filewrite browser "\t\tFILE_ATTRIBUTE_DEVICE (0x40)\n"
endif
if (H_Attr and 0x80)
  filewrite browser "\t\tFILE_ATTRIBUTE_NORMAL (0x80)\n"
endif
if (H_Attr and 0x100)
  filewrite browser "\t\tFILE_ATTRIBUTE_TEMPORARY (0x0100)\n"
endif
if (H_Attr and 0x200)
  filewrite browser "\t\tFILE_ATTRIBUTE_SPARSE_FILE (0x0200)\n"
endif
if (H_Attr and 0x400)
  filewrite browser "\t\tFILE_ATTRIBUTE_REPARSE_POINT (0x0400)\n"
endif
if (H_Attr and 0x800)
  filewrite browser "\t\tFILE_ATTRIBUTE_COMPRESSED (0x0800)\n"
endif
if (H_Attr and 0x1000)
  filewrite browser "\t\tFILE_ATTRIBUTE_OFFLINE (0x1000)\n"
endif
if (H_Attr and 0x2000)
  filewrite browser "\t\tFILE_ATTRIBUTE_NOT_CONTENT_INDEXED (0x2000)\n"
endif
if (H_Attr and 0x4000)
  filewrite browser "\t\tFILE_ATTRIBUTE_ENCRYPTED (0x4000)\n"
endif

fileread editor H_Create 
fileread editor H_Modified 
fileread editor H_LastAccess
filewrite browser "\nCreated:\t", #myhex(H_Create)," (",#FileTimeToString(H_Create),")\n"
filewrite browser "Modified:\t", #myhex(H_Modified)," (",#FileTimeToString(H_Modified),")\n"
filewrite browser "Last Access:\t", #myhex(H_LastAccess)," (",#FileTimeToString(H_LastAccess),")\n"

fileread editor H_FileLen
filewrite browser "\nFile size:\t", DEC(H_FileLen),"\n"

fileread editor H_IconIndex
if (H_Flags and 64)
  filewrite browser "Icon index:\t", DEC(H_IconIndex),"\n"
else
  filewrite browser "Icon index:\t", DEC(H_IconIndex)," (Unused)\n"
endif

fileread editor H_ShowWnd
filewrite browser "ShowWnd:\t", #getshowwnd(H_ShowWnd),"\n"

fileread editor H_Hotkey
filewrite browser "Hotkey:\t", #myhex(H_hotkey),"\n"

fileread editor H_Stuff
filewrite browser "Reserved:\t", hex(H_Stuff),"\n\n"


= item id list
if (H_Flags and 1)
  var IID_Len word IID_Text text
  fileread editor IID_Len
  IID_text = "Shell Item ID List"
  TagVar IID_Text FilePos(editor) IID_Len
  filewrite browser "-- ", IID_Text, " --\nLength:\t", #myhex(IID_Len),"\n\n"
  fileseek editor IID_Len 1
endif

= file location info
if (H_Flags and 2)
  var FLI_Pos dword
  FLI_Pos = filepos(editor)
  var FLI_Len DWORD FLI_OffsetAfter dword FLI_VolumeFlags dword FLI_LocalVolOfs dword
  var FLI_LocalBasePathOfs dword FLI_NetVolInfoOfs dword FLI_RemPathOfs dword FLI_Text text
  fileread editor FLI_Len
  FLI_text = "File Location info"
  TagVar fli_text FilePos(editor)-4 fli_Len
  filewrite browser "-- ", fli_Text, " --\nLength:\t\t", #myhex(fli_Len),"\n"
  fileread editor FLI_OffsetAfter 
  fileread editor FLI_VolumeFlags 
  fileread editor FLI_LocalVolOfs 
  fileread editor FLI_LocalBasePathOfs 
  fileread editor FLI_NetVolInfoOfs 
  fileread editor FLI_RemPathOfs
  FLI_text = "OffsetAfter:"
  tagvar fli_text fli_pos+fli_offsetafter,0
  filewrite browser FLI_text, "\t\t", #myhex(FLI_OffsetAfter),"\n"
  tagvar FLI_TEXT,,
  fli_text =""
  if (FLI_VolumeFlags and 1): fli_text = "Local file":endif
  if (FLI_VolumeFlags and 2): if (fli_text != ""): concat fli_text, ", ":endif:concat fli_text "Network file":endif
  if (fli_text != "")
    fli_text = " ("+fli_text+")"
  endif
  filewrite browser "Volume flags:\t\t", #myhex(FLI_VolumeFlags),fli_text,"\n"
  if (FLI_VolumeFlags and 1)
    FLI_text = "Local vol offset:"
    tagvar fli_text fli_pos+FLI_LocalVolOfs,0
    filewrite browser fli_text, "\t", #myhex(FLI_LocalVolOfs),"\n"
    FLI_text = "Local base offset:"
    tagvar fli_text fli_pos+FLI_LocalBasePathOfs,0
    filewrite browser FLI_text, "\t", #myhex(FLI_LocalBasePathOfs),"\n"
  else
    filewrite browser "Local vol offset:\t", #myhex(FLI_LocalVolOfs)," (unused)\n"
    filewrite browser "Local base offset:\t", #myhex(FLI_LocalBasePathOfs)," (unused)\n"
  endif
  if (FLI_VolumeFlags and 2)
    FLI_text = "Net vol offset:"
    tagvar fli_text fli_pos+FLI_NetVolInfoOfs,0
    filewrite browser fli_text, "\t", #myhex(FLI_NetVolInfoOfs),"\n"
    FLI_text = "Net base offset:"
    tagvar fli_text fli_pos+FLI_RemPathOfs,0
    filewrite browser FLI_text, "\t", #myhex(FLI_RemPathOfs),"\n"
  else
    filewrite browser "Net vol offset:\t", #myhex(FLI_NetVolInfoOfs)," (unused)\n"
    filewrite browser "Net base offset:\t", #myhex(FLI_RemPathOfs)," (unused)\n"
  endif
  if (FLI_VolumeFlags and 1)
    fileseek editor fli_pos+FLI_LocalVolOfs
    var lvt_len dword lvt_type dword lvt_serial dword lvt_ofslabel dword
    fileread editor lvt_len
    fileread editor lvt_type
    fileread editor lvt_serial
    fileread editor lvt_ofslabel
    FLI_text = "Local volume table"
    tagvar fli_text fli_pos+FLI_LocalVolOfs,lvt_len
    filewrite browser "\n  -- ", fli_Text, " --\n  Length:\t\t", #myhex(lvt_Len),"\n"
    filewrite browser "  Volume type:\t\t", #getlocalvoltype(lvt_type),"\n"
    filewrite browser "  Volume serial:\t", #myhex(lvt_serial),"\n"
    FLI_text = "Label offset"
    tagvar fli_text fli_pos+FLI_LocalVolOfs+lvt_ofslabel,0
    filewrite browser "  ",fli_text,":\t", #myhex(lvt_ofslabel),"\n"
    fileseek editor fli_pos+FLI_LocalVolOfs+lvt_ofslabel
    fileread editor fli_text
    filewrite browser "  Volume label:\t", fli_text,"\n"

    = read local base name
    fileseek editor fli_pos+FLI_LocalBasePathOfs
    fileread editor fli_text
    filewrite browser "\nLocal path:\t\t", fli_text,"\n"
    
  endif
  if (FLI_VolumeFlags and 2)
    fileseek editor fli_pos+FLI_NetVolInfoOfs
    var nvt_len dword nvt_type dword nvt_ofsshare dword nvt_res SigQWord
    fileread editor nvt_len
    fileread editor nvt_type
    fileread editor nvt_ofsshare
    fileread editor nvt_res
    FLI_text = "Network volume table"
    tagvar fli_text fli_pos+FLI_NetVolInfoOfs,nvt_len
    filewrite browser "\n  -- ", fli_Text, " --\n  Length:\t\t", #myhex(nvt_Len),"\n"
    filewrite browser "  Volume type (?):\t", #myhex(nvt_type),"\n"
    FLI_text = "Share offset"
    tagvar fli_text fli_pos+FLI_NetVolInfoOfs+nvt_ofsshare,0
    filewrite browser "  ",fli_text,":\t", #myhex(nvt_ofsshare),"\n"
    filewrite browser "  unknown:\t\t", #myhex(nvt_res),"\n"
    fileseek editor fli_pos+FLI_NetVolInfoOfs+nvt_ofsshare
    fileread editor fli_text
    filewrite browser "  Share name:\t\t", fli_text,"\n"

    = read network base name
    fileseek editor fli_pos+FLI_RemPathOfs
    fileread editor fli_text
    filewrite browser "\nRemote path:\t\t", fli_text,"\n"
    
  endif
  fileseek editor fli_pos+fli_len
endif

if (H_Flags and 4):= description string
  filewrite browser "\nDescription:\t\t", #myreadstring, "\n"
endif
if (H_Flags and 8):= relative path
  filewrite browser "\nRelative path:\t\t", #myreadstring, "\n"
endif
if (H_Flags and 0x10):= working dir
  filewrite browser "\nWorking directory:\t", #myreadstring, "\n"
endif
if (H_Flags and 0x20):= command line
  filewrite browser "\nCmdline:\t\t", #myreadstring, "\n"
endif
if (H_Flags and 0x40):= icon frilename
  filewrite browser "\nIcon filename:\t\t", #myreadstring, "\n"
endif

= other data
var other dword
other = filesize(editor) - filepos(editor)
tagvar other, filepos(editor), other

filewrite browser "\nOther data:\t\t", dec(other), " bytes\n"

