INCLUDE '*.lng'
=
=	export data as hexadecimal text
=	exporter script for mirkes.de's tiny hex editor
=
=	(C) markus stephany, tinyhexer[at]mirkes[dot]de
=
=  params: 1=out file, 2=start, 3=count

option GLOBALVARS, 1
option target, export

var count dword start dword outfn text outf file inf file blsize dword cur dword

= get the export file name
if param_count > 0
  outfn = params(0)
else
  outfn = asksavefilename(__STR1__, __STR2__, 'txt')
endif

inf = fileopen('::current')
start = 0
count = filesize(inf)

= get amount of data to store
if param_count > 1
  start = dword(params(1))
  fileseek inf start
  if param_count > 2
    count = dword(params(2))
  endif
endif

= open out file
outf = fileopen(outfn,'c')
fileseek outf (3 * count)
fileseek outf 0

blsize = filegetprop(inf, 'BytesPerRow')
var c_data byte
while cur < count
  fileread inf c_data
  filewrite outf hex(c_data), " "
  inc cur
  if (not (cur mod blsize))
    filewrite outf "\r\n"
    showprogress count cur
  endif
endwhile

showprogress 100
fileclose outf
fileclose inf
end


