=	export data in motorola's s-record format
=	exporter script for mirkes.de's tiny hex editor
=
=	(C) markus stephany, tinyhexer[at]mirkes[dot]de
=
=  params: 1=out file, 2=start, 3=count

INCLUDE 'def.mps'
INCLUDE 'gui.mps'

option GLOBALVARS, 1
option target, export


var count dword start dword outfn text outf file inf file 
var lastaddr dword:= last address to be exported
var addrtype byte:= type of the address record (0 = s19, 1 = s28, 2 = s37)
var written dword:= number of bytes written
var desc text:= file description
var skipbyte byte:= skip byte for unoccupied space
var doskip byte:= is skip byte set?
var lineaddr dword
var cmd char:= command to write

var voffset dword:= virtual offset, depending on the range of the input file (and the range of the output file, if 
                  = importing to an existing file             

INCLUDE '*.lng'

= get the export file name
if param_count > 0
  outfn = params(0)
else
  outfn = asksavefilename(__STR1__, __STR2__, 'mot')
endif

inf = fileopen('::current')
start = 0
count = filesize(inf)


= get amount of data to store
if param_count > 1
  start = dword(params(1))
  fileseek inf start
  if param_count > 2
    count = dword(params(2))
  endif
endif

voffset = filegetprop(inf, '!Offset')+start
lastaddr = start+count-1
skipbyte = filegetprop(inf, 'FillByte')
errorhandler __no__desc
desc = filegetprop(inf, '!Description')
goto start
@@__no__desc
errorhandler none
desc = ''


var lb text


@@start
= get file options thru a dialog
if GuiExists('dlgExportMotorola'):GuiDestroy('dlgExportMotorola'):endif

call create_form


var b_ok byte
= show dialog
b_ok = GuiShowModal('dlgExportMotorola') == IDOK
GuiDestroy('dlgExportMotorola'):= destroy dialog
if b_ok

  = open out file
  outf = fileopen(outfn,'c')
  

  = write all data
  var cur dword data text cur_v dword
  cur = start
  cur_v = voffset 
  fileseek inf, start
  cmd = '0'
  call writerec data2textbe(byte(textlen(desc)+3))+data2textbe(word(0))+desc
  call(lb):= use function as it can jump to variable targets (needed to distinguish between s19/s28/s37 records)
  
  fileclose inf
  showprogress 100

  fileclose outf

endif
end

var c_read char max_v dword


@@rw_s19:= 16 bit addresses
cmd = '1'
repeat
  showprogress count written
  if doskip:call findstart:endif
  lineaddr = cur_v
  = calculate max_v 
  max_v = cur_v +31:= max 32 bytes per record
  data = ''
  repeat
    if cur > lastaddr:goto w_s19:endif
    if (fileread(inf, @c_read))
      inc cur
      inc cur_v
      if doskip and (c_read == skipbyte):goto w_s19:endif
      concat data, c_read
    else
      goto w_s19
    endif  
  until cur_v > max_v

@@w_s19
  if data != ''
    inc written, textlen(data)
    call writerec data2textbe(byte(textlen(data)+3))+data2textbe(word(lineaddr))+data
  endif 
until cur > lastaddr
filewrite outf "S9030000FC\r\n"
return

@@rw_s28:= 24 bit addresses
cmd = '2'
repeat
  showprogress count written
  if doskip:call findstart:endif
  lineaddr = cur_v
  = calculate max_v 
  max_v = cur_v +31:= max 32 bytes per record
  data = ''
  repeat
    if cur > lastaddr:goto w_s28:endif
    if (fileread(inf, @c_read))
      inc cur
      inc cur_v
      if doskip and (c_read == skipbyte):goto w_s28:endif
      concat data, c_read
    else
      goto w_s28
    endif  
  until cur_v > max_v

@@w_s28
  if data != ''
    inc written, textlen(data)
    call writerec data2textbe(byte(textlen(data)+4))+textcopy(data2textbe(dword(lineaddr)),2)+data
  endif 
until cur > lastaddr
filewrite outf "S804000000FB\r\n"
return

@@rw_s37:= 32 bit addresses
cmd = '3'
repeat
  showprogress count written
  if doskip:call findstart:endif
  lineaddr = cur_v
  = calculate max_v 
  max_v = cur_v +31:= max 32 bytes per record
  data = ''
  repeat
    if cur > lastaddr:goto w_s37:endif
    if (fileread(inf, @c_read))
      inc cur
      inc cur_v
      if doskip and (c_read == skipbyte):goto w_s37:endif
      concat data, c_read
    else
      goto w_s37
    endif  
  until cur_v > max_v

@@w_s37
  if data != ''
    inc written, textlen(data)
    call writerec data2textbe(byte(textlen(data)+5))+data2textbe(dword(lineaddr))+data
  endif 
until cur > lastaddr
filewrite outf "S70500000000FA\r\n"
return

@@findstart:= read over skipbyte
if cur > lastaddr:return:endif
fileread inf c_read
inc cur
inc cur_v
if (c_read != skipbyte) or (cur > lastaddr)
  inc cur -1
  inc cur_v -1
  fileseek inf, -1, file_current
  return
endif
goto findstart


@@writerec:= build checksum and write the record
var w_dat text w_sum byte w_index word w_len word
pop w_dat
w_sum = 0
w_index = 1
w_len = textlen(w_dat)+1
while w_index < w_len
  inc w_sum, byte(char(textcopy(w_dat,w_index,1)))
  inc w_index
endwhile
filewrite outf "S"+cmd+bin2hex(w_dat)+bin2hex(data2textbe(byte(255-w_sum)))+"\r\n"
return

@@check_dialog:= check dialog values
var cdt text c_offs dword 

GuiSetProp('dlgExportMotorola.edOffs', 'Focused', True)
cdt = GuiGetProp('dlgExportMotorola.edoffs', 'Text')
if (not IsNumber(cdt)):goto check_dialog_num_error:endif
c_offs = dword(cdt)

GuiSetProp('dlgExportMotorola.edSkip', 'Focused', True)
cdt = GuiGetProp('dlgExportMotorola.edSkip', 'Text')
if (not IsNumber(cdt)):goto check_dialog_num_error:endif
skipbyte = byte(cdt)

desc = GuiGetProp('dlgExportMotorola.edDesc', 'Text')

voffset = c_offs
doskip = GuiGetProp('dlgExportMotorola.cbSkip', 'Checked')

addrtype = guigetprop('dlgExportMotorola.rgAddr', 'ItemIndex')

GuiSetProp('dlgExportMotorola.rgAddr', 'Focused', True)
= prepare read and write procs depending on addrtype
if addrtype == 1
  lb = "rw_s28"
  if (lastaddr + voffset) > 0xffffff
    = address range too large for 24 bit records
    if MsgBox(__STR3__, MB_ICONHAND or MB_YESNO) == IDNO
      goto check_dialog_cancel_close
    endif
  endif
else
  if addrtype == 2
    lb = "rw_s37"
  else
    lb = "rw_s19"
  endif
  if addrtype == 0 
    if (lastaddr + voffset) > 0xffff
      = address range too large for 16 bit records
      if MsgBox(__STR4__, MB_ICONHAND or MB_YESNO) == IDNO
        goto check_dialog_cancel_close
      endif
    endif
  endif
endif


return

@@check_dialog_num_error
msgbox __STR5__, MB_ICONSTOP
@@check_dialog_cancel_close
GuiSetProp('dlgExportMotorola', 'ModalResult', 0)
return



