INCLUDE '*.lng'
=
=	export data as pascal source code table
=	exporter script for mirkes.de's tiny hex editor
=
=	(C) markus stephany, tinyhexer[at]mirkes[dot]de
=
=  params: 1=out file, 2=start, 3=count

option GLOBALVARS, 1
  option target, export

var count dword start dword outfn text outf file inf file blocks dword rest dword blsize dword cur dword

= get the export file name
if param_count > 0
  outfn = params(0)
else
  outfn = asksavefilename(__STR1__, __STR2__, 'inc')
endif

inf = fileopen('::current')
start = 0
count = filesize(inf)

= get amount of data to store
if param_count > 1
  start = dword(params(1))
  fileseek inf start
  if param_count > 2
    count = dword(params(2))
  endif
endif

= open out file
outf = fileopen(outfn,'c')
number_radix = 10
number_prefix = ''
number_suffix = ''

blsize = filegetprop(inf, 'BytesPerRow')
blocks = count / blsize
rest = count mod blsize
filewrite outf "(*\r\n  table exported by mirkes.de's tiny hexer\r\n"
filewrite outf ("  filename: "+filegetprop(inf,'filename')+"\r\n")
filewrite outf ("  position "+text(start)+", "+text(count)+" bytes\t *)\r\n\r\n")
filewrite outf ("const TABLE: array [0.."+text(count-1)+"] of char =\r\n")
filewrite outf "(\r\n"

cur = 0
loop LINE blocks
if rest > 0
  blsize = rest
  call LINE
endif

filewrite outf "  );\r\n"
showprogress 100
fileclose outf
fileclose inf
end

@@LINE
showprogress count cur
filewrite outf "    "
loop CHAR blsize
filewrite outf "\r\n"
return

@@CHAR
var b byte
var o text
inc cur 1
fileread inf b
o = text(b)
filewrite outf (TextCopy('  #', textlen(o))+o)
if cur != count
  filewrite outf ', '
endif
return


