=	import a file in intel hex format
=	importer script for mirkes.de's tiny hex editor
=
=	(C) markus stephany, tinyhexer[at]mirkes[dot]de
=
INCLUDE 'def.mps'
INCLUDE 'gui.mps'

option globalvars, 1
option target, import

var line text lines dword infilen text infile file outfile file cmd text cur dword bytes word curpos word
var nfilename text
var firstaddr dword:= first address in the file to be imported
var lastaddr dword:= highest used address in the file to be imported
firstaddr = -1
var fillbyte byte:= fill byte for unoccupied space
fillbyte = 255:= for eproms, may be changed in the dialog

var voffset dword:= virtual offset, depending on the range of the input file (and the range of the output file, if 
                  = importing to an existing file)             

var f_new byte:= importing to a new file?

include '*.lng'

= get the import file name
nfilename = '::new'
if param_count > 0
  infilen = params(0)
  if param_count > 1
    nfilename = params(1)
  endif
else
  infilen = askopenfilename(__STR1__, __STR2__)
endif

= open the import file
infile = fileopen(infilen)

f_new = textupper(nfilename) == '::NEW'

call check_infile 


= now fork depending on the f_new flag
if f_new:goto importtonew:endif

= import to current file (voffset and fillbyte are disabled)

outfile = fileopen(nfilename, 'rw')
errorhandler ex_1
voffset = 0
FillByte = 0xff
voffset = filegetprop(outfile, '!Offset')
FillByte = filegetprop(outfile, 'FillByte')
@@ex_1:errorhandler none

= get file options thru a dialog
if GuiExists('dlgImportIntelHex'):GuiDestroy('dlgImportIntelHex'):endif

call create_form_1

var b_ok byte
= show dialog
b_ok = GuiShowModal('dlgImportIntelHex') == IDOK
GuiDestroy('dlgImportIntelHex'):= destroy dialog
if b_ok

  = set filesize (lastaddr - voffset +1) if currently smaller
  if (FileGetProp(outfile, 'Size') <= (lastaddr - voffset))
    filesetprop outfile, 'Size', lastaddr - voffset +1
  endif
  filesetprop outfile, 'InsertMode', False:= force overwrite mode
  call write_infile:= write the input file
  fileclose infile
  showprogress 100
endif

fileclose outfile

end

@@importtonew:= import to a new file

= get file options thru a dialog
if GuiExists('dlgImportIntelHex'):GuiDestroy('dlgImportIntelHex'):endif

call create_form_2

= show dialog
b_ok = GuiShowModal('dlgImportIntelHex') == IDOK
GuiDestroy('dlgImportIntelHex'):= destroy dialog
if b_ok
  outfile = fileopen(nfilename, 'c')
  filesetprop outfile, '!Offset', voffset
  filesetprop outfile, 'FillByte', FillByte

  = set filesize (lastaddr - voffset +1)
  filesetprop outfile, 'Size', lastaddr - voffset +1
  filesetprop outfile, 'InsertMode', False:= force overwrite mode
  call write_infile:= write the input file
  fileclose infile
  fileclose outfile
  showprogress 100
endif


end

@@check_dialog:= check dialog values
var cdt text c_offs dword c_from dword c_to dword c_fill byte

GuiSetProp('dlgImportIntelHex.edOffs', 'Focused', True)
cdt = GuiGetProp('dlgImportIntelHex.edoffs', 'Text')
if (not IsNumber(cdt)):goto check_dialog_num_error:endif
c_offs = dword(cdt)

GuiSetProp('dlgImportIntelHex.edFrom', 'Focused', True)
cdt = GuiGetProp('dlgImportIntelHex.edFrom', 'Text')
if (not IsNumber(cdt)):goto check_dialog_num_error:endif
if (dword(cdt) < c_offs):goto check_dialog_number_error:endif
c_from = dword(cdt)

GuiSetProp('dlgImportIntelHex.edTo', 'Focused', True)
cdt = GuiGetProp('dlgImportIntelHex.edTo', 'Text')
if (not IsNumber(cdt)):goto check_dialog_num_error:endif
c_To = dword(cdt)

GuiSetProp('dlgImportIntelHex.edFill', 'Focused', True)
cdt = GuiGetProp('dlgImportIntelHex.edFill', 'Text')
if (not IsNumber(cdt)):goto check_dialog_num_error:endif
c_fill = byte(cdt)

= assure to is smaller than from
GuiSetProp('dlgImportIntelHex.edTo', 'Focused', True)
if (c_to < c_from):goto check_dialog_number_error:endif
GuiSetProp('dlgImportIntelHex.edOffs', 'Focused', True)
if (c_offs > lastaddr):goto check_dialog_number_error:endif

voffset = c_offs
firstaddr = c_from
lastaddr = c_to
fillbyte = c_fill

return

@@check_dialog_num_error
msgbox __STR3__, MB_ICONSTOP
GuiSetProp('dlgImportIntelHex', 'ModalResult', 0)
return

@@check_dialog_number_error
msgbox __STR3a__, MB_ICONSTOP
GuiSetProp('dlgImportIntelHex', 'ModalResult', 0)
return

@@check_infile:= check input file integrity and collect positions and description

= get the number of lines in the input file
lines = 0

var fsz dword
fsz = filegetprop(infile, 'size') 

repeat
  filereadtextline infile line 1
  inc lines 1
until (filegetprop(infile, 'position') >= fsz)
inc lines -1

var lines_d dword
lines_d = lines * 2

var cur_addr dword cur_data text cur_datalen word cur_iofs dword

cur=0
fileseek infile FILE_BEGIN
repeat
  = read a line of text from the file
  showprogress lines_d cur
  filereadtextline infile line 1
  inc cur 1
  if line == '':goto ch_next:endif
  call getlinedata
  ifgoto cmd, '00', ch_data: goto ch_next
@@ch_data
  = '00' data command
  if (firstaddr > cur_addr): firstaddr = cur_addr:endif
  if ((cur_addr + cur_datalen-1) > lastaddr): lastaddr = cur_addr + cur_datalen-1:endif
@@ch_next
until cur > lines
return



@@write_infile:= write the input file

cur=0
fileseek infile FILE_BEGIN
repeat
  = read a line of text from the file
  showprogress lines_d cur+lines
  filereadtextline infile line 1
  inc cur 1
  if line == '':goto wi_next:endif
  call getlinedata
  ifgoto cmd, '00', wi_data: goto wi_next

@@wi_data
  = check if address+length matches the editor file window
  var l_pos dword
  l_pos = cur_addr + cur_datalen -1
  if l_pos > lastaddr
    = strip end
    cur_data = textcopy(cur_data, 1, cur_datalen-(l_pos - lastaddr))
    cur_datalen = textlen(cur_data)
  endif
  if cur_addr < firstaddr
    = strip beginning
    cur_data = textcopy(cur_data, firstaddr - cur_addr+1)
    cur_addr = firstaddr
    cur_datalen = textlen(cur_data)
  endif 
  fileseek outfile, (cur_addr - voffset)
  filewrite outfile cur_data

@@wi_next
until cur > lines
return


@@getlinedata:= parse a line
var gl_line text
gl_line = hex2bin(textcopy(line,2))
if (textcopy(line,1,1) != ':'): error line+__STR4__:endif
cmd = textcopy(line, 8,2)

ifgoto cmd, '00', gl_weiter, '01', gl_weiter, '02', gl_weiter, '03', gl_weiter, '04', gl_weiter, '05', gl_weiter
error line+__STR5__
@@gl_weiter

var chsum byte
var al word
al = textlen(gl_line)-2


= calculate checksum
chsum = 0
curpos = 0
repeat
  inc chsum, text2databe(gl_line, curpos,1)
  inc curpos
until curpos > al


bytes = text2databe(textcut(@gl_line,1,1)):= amount of bytes
if (textlen(line) != ((bytes*2)+11)):error line+__STR6__:endif

= depending on the record type, get the address
ifgoto cmd, '00', gl_a_data, '02', gl_a_segment, '04', gl_a_linear:goto gl_a_none
@@gl_a_data 
= data record, calculate the current address
cur_addr = text2databe(textcut(@gl_line, 1, 2)) + cur_iofs
textcut(@gl_line,1,1)
goto gl_a_none

@@gl_a_segment
= set segment offset address
cur_iofs = text2databe(textcut(@gl_line, 4,2)) << 4
goto gl_a_none

@@gl_a_linear
= set linear offset address
cur_iofs = text2databe(textcut(@gl_line, 4,2)) << 16

@@gl_a_none

var b1 byte
b1 = 0
inc b1, -text2databe(textcut(@gl_line, TextLen(gl_line),1))

cur_data = gl_line
cur_datalen = textlen(cur_data)


if (chsum != b1)
  error line+__STR7__
endif
return

