=	import a file in motorola srecord format
=	importer script for mirkes.de's tiny hex editor
=
=	(C) markus stephany, tinyhexer[at]mirkes[dot]de
=
INCLUDE 'def.mps'
INCLUDE 'gui.mps'

option globalvars, 1
option target, import

var line text lines dword infilen text infile file outfile file cmd text cur dword bytes word curpos word
var nfilename text
var firstaddr dword:= first address in the file to be imported
var lastaddr dword:= highest used address in the file to be imported
firstaddr = -1
var fillbyte byte:= fill byte for unoccupied space
fillbyte = 255:= for eproms, may be changed in the dialog
var desc text:= description of the motorola file

var voffset dword:= virtual offset, depending on the range of the input file (and the range of the output file, if 
                  = importing to an existing file             

var f_new byte:= importing to a new file?
include '*.lng'

= get the import file name
nfilename = '::new'
if param_count > 0
  infilen = params(0)
  if param_count > 1
    nfilename = params(1)
  endif
else
  infilen = askopenfilename(__STR1__, __STR2__)
endif

= open the import file
infile = fileopen(infilen)

f_new = textupper(nfilename) == '::NEW'

call check_infile 


= now fork depending on the f_new flag
if f_new:goto importtonew:endif

= import to current file (voffset and fillbyte are disabled)

outfile = fileopen(nfilename, 'rw')
errorhandler ex_1
voffset = 0
desc=''
FillByte = 0xff
voffset = filegetprop(outfile, '!Offset')
desc = filegetprop(outfile, '!Description')
FillByte = filegetprop(outfile, 'FillByte')
@@ex_1:errorhandler none

= get file options thru a dialog
if GuiExists('dlgImportMotorola'):GuiDestroy('dlgImportMotorola'):endif

call create_form_1

var b_ok byte
= show dialog
b_ok = GuiShowModal('dlgImportMotorola') == IDOK
GuiDestroy('dlgImportMotorola'):= destroy dialog
if b_ok
  if desc != '':filesetprop outfile, '!Description', desc:endif

  = set filesize (lastaddr - voffset +1) if currently smaller
  if (FileGetProp(outfile, 'Size') <= (lastaddr - voffset))
    filesetprop outfile, 'Size', lastaddr - voffset +1
  endif
  filesetprop outfile, 'InsertMode', False:= force overwrite mode
  call write_infile:= write the input file
  fileclose infile
  showprogress 100
endif

fileclose outfile

end

@@importtonew:= import to a new file

= get file options thru a dialog
if GuiExists('dlgImportMotorola'):GuiDestroy('dlgImportMotorola'):endif

call create_form_2

= show dialog
b_ok = GuiShowModal('dlgImportMotorola') == IDOK
GuiDestroy('dlgImportMotorola'):= destroy dialog
if b_ok
  outfile = fileopen(nfilename, 'c')
  if desc != '':filesetprop outfile, '!Description', desc:endif
  filesetprop outfile, '!Offset', voffset
  filesetprop outfile, 'FillByte', FillByte

  = set filesize (lastaddr - voffset +1)
  filesetprop outfile, 'Size', lastaddr - voffset +1
  filesetprop outfile, 'InsertMode', False:= force overwrite mode
  call write_infile:= write the input file
  fileclose infile
  fileclose outfile
  showprogress 100
endif


end

@@check_dialog:= check dialog values
var cdt text c_offs dword c_from dword c_to dword c_fill byte

GuiSetProp('dlgImportMotorola.edOffs', 'Focused', True)
cdt = GuiGetProp('dlgImportMotorola.edoffs', 'Text')
if (not IsNumber(cdt)):goto check_dialog_num_error:endif
c_offs = dword(cdt)

GuiSetProp('dlgImportMotorola.edFrom', 'Focused', True)
cdt = GuiGetProp('dlgImportMotorola.edFrom', 'Text')
if (not IsNumber(cdt)):goto check_dialog_num_error:endif
if (dword(cdt) < c_offs):goto check_dialog_number_error:endif
c_from = dword(cdt)

GuiSetProp('dlgImportMotorola.edTo', 'Focused', True)
cdt = GuiGetProp('dlgImportMotorola.edTo', 'Text')
if (not IsNumber(cdt)):goto check_dialog_num_error:endif
c_To = dword(cdt)

GuiSetProp('dlgImportMotorola.edFill', 'Focused', True)
cdt = GuiGetProp('dlgImportMotorola.edFill', 'Text')
if (not IsNumber(cdt)):goto check_dialog_num_error:endif
c_fill = byte(cdt)

= assure to is smaller than from
GuiSetProp('dlgImportMotorola.edTo', 'Focused', True)
if (c_to < c_from):goto check_dialog_number_error:endif
GuiSetProp('dlgImportMotorola.edOffs', 'Focused', True)
if (c_offs > lastaddr):goto check_dialog_number_error:endif

voffset = c_offs
firstaddr = c_from
lastaddr = c_to
desc = GuiGetProp('dlgImportMotorola.edDesc', 'Text')
fillbyte = c_fill

return

@@check_dialog_num_error
msgbox __STR3__, MB_ICONSTOP
GuiSetProp('dlgImportMotorola', 'ModalResult', 0)
return

@@check_dialog_number_error
msgbox __STR3a__, MB_ICONSTOP
GuiSetProp('dlgImportMotorola', 'ModalResult', 0)
return

@@check_infile:= check input file integrity and collect positions and description

= get the number of lines in the input file
lines = 0

var fsz dword
fsz = filegetprop(infile, 'size') 

repeat
  filereadtextline infile line 1
  inc lines 1
until (filegetprop(infile, 'position') >= fsz)
inc lines -1

var lines_d dword
lines_d = lines * 2

var cur_addr dword cur_data text cur_datalen word

var exp_end text:= expected block end marker

cur=0
fileseek infile FILE_BEGIN
repeat
  = read a line of text from the file
  showprogress lines_d cur
  filereadtextline infile line 1
  inc cur 1
  if line == '':goto ch_next:endif
  call getlinedata
  ifgoto cmd, 'S1', ch_s1, 'S2', ch_s2, 'S3', ch_s3, 'S5', ch_next, 'S7', ch_s7, 'S8', ch_s8, 'S9', ch_s9
  = S0 command
  desc=cur_data:goto ch_next
@@ch_s1
  = S1 command
  if ((exp_end != ''  ) and (exp_end != 'S9')):goto wrong_command:endif
  if (firstaddr > cur_addr): firstaddr = cur_addr:endif
  if ((cur_addr + cur_datalen-1) > lastaddr): lastaddr = cur_addr + cur_datalen-1:endif
  exp_end = 'S9':goto ch_next

@@ch_s2
  = S2 command
  if ((exp_end != ''  ) and (exp_end != 'S8')):goto wrong_command:endif
  if (firstaddr > cur_addr): firstaddr = cur_addr:endif
  if ((cur_addr + cur_datalen-1) > lastaddr): lastaddr = cur_addr + cur_datalen-1:endif
  exp_end = 'S8':goto ch_next

@@ch_s3
  = S3 command
  if ((exp_end != ''  ) and (exp_end != 'S7')):goto wrong_command:endif
  if (firstaddr > cur_addr): firstaddr = cur_addr:endif
  if ((cur_addr + cur_datalen-1) > lastaddr): lastaddr = cur_addr + cur_datalen-1:endif
  exp_end = 'S7':goto ch_next

@@ch_s7
  = S7 command
  if (exp_end != 'S7')
    if (MsgBox(__STR4__+exp_end+__STR5__, MB_ICONWARNING or MB_OKCANCEL) == IDCANCEL)
      end
    endif
  endif
  exp_end = '': goto ch_next

@@ch_s8
  = S8 command
  if (exp_end != 'S8')
    if (MsgBox(__STR6__+exp_end+__STR5__, MB_ICONWARNING or MB_OKCANCEL) == IDCANCEL)
      end
    endif
  endif
  exp_end = '': goto ch_next

@@ch_s9
  = S9 command
  if (exp_end != 'S9')
    if (MsgBox(__STR7__+exp_end+__STR5__, MB_ICONWARNING or MB_OKCANCEL) == IDCANCEL)
      end
    endif
  endif
  exp_end = ''

@@ch_next
until cur > lines
if exp_end != ''
  if (MsgBox(__STR8__+exp_end+__STR5__, MB_OKCANCEL or MB_ICONHAND) == IDCANCEL):END:ENDIF
endif
return

@@wrong_command
if (exp_end == 'S9'):error line+__STR9__:endif
if (exp_end == 'S8'):error line+__STR10__:endif
if (exp_end == 'S7'):error line+__STR11__:endif
error line+': invalid command'



@@write_infile:= write the input file

cur=0
fileseek infile FILE_BEGIN
repeat
  = read a line of text from the file
  showprogress lines_d cur+lines
  filereadtextline infile line 1
  inc cur 1
  if line == '':goto wi_next:endif
  call getlinedata
  ifgoto cmd, 'S0', wi_next, 'S5', wi_next, 'S7', wi_next, 'S8', wi_next, 'S9', wi_next

  = check if address+length matches the editor file window
  var l_pos dword
  l_pos = cur_addr + cur_datalen -1
  if l_pos > lastaddr
    = strip end
    cur_data = textcopy(cur_data, 1, cur_datalen-(l_pos - lastaddr))
    cur_datalen = textlen(cur_data)
  endif
  if cur_addr < firstaddr
    = strip beginning
    cur_data = textcopy(cur_data, firstaddr - cur_addr+1)
    cur_addr = firstaddr
    cur_datalen = textlen(cur_data)
  endif 
  fileseek outfile, (cur_addr - voffset)
  filewrite outfile cur_data

@@wi_next
until cur > lines
return


@@getlinedata:= parse a line
var gl_line text
gl_line = hex2bin(textcopy(line,3))
cmd = textcopy(line, 1, 2)
ifgoto cmd, 'S0', gl_weiter, 'S1', gl_weiter, 'S2', gl_weiter, 'S3', gl_weiter, 'S5', gl_weiter, 'S7', gl_weiter, 'S8', gl_weiter, 'S9', gl_weiter
error line+__STR12__
@@gl_weiter

var chsum byte
var al word
al = textlen(gl_line)-2


= calculate checksum
chsum = 0
curpos = 0
repeat
  inc chsum, text2databe(gl_line, curpos,1)
  inc curpos
until curpos > al



bytes = text2databe(textcut(@gl_line,1,1)):= amount of bytes
if (textlen(line) != ((bytes*2)+4)):error line+__STR13__:endif

= depending on the record type, get the address
if ((cmd == 'S3') or (cmd == 'S7'))
  cur_addr=text2databe(textcut(@gl_line, 1, 4))
else
  if ((cmd == 'S2') or (cmd == 'S8'))
    cur_addr=text2databe(textcut(@gl_line, 1, 3))
  else
    cur_addr=text2databe(textcut(@gl_line, 1, 2))
  endif
endif


var b1 byte
b1 = 255
inc b1, -text2databe(textcut(@gl_line, TextLen(gl_line),1))

cur_data = gl_line
cur_datalen = textlen(cur_data)

if (chsum != b1)
  error line+__STR14__
endif
return

