= standard definitions
=

= bool constants, do not use TRUE in the form "if a == TRUE", use "if a != FALSE" instead!
DEF TRUE 1
DEF FALSE 0


= data type sizes
DEF CHAR_SIZE 1
DEF BYTE_SIZE 1
DEF WORD_SIZE 2
DEF LONGWORD_SIZE 4
DEF SIGNED_QWORD_SIZE 8
DEF SIGQWORD_SIZE 8
DEF SINGLE_SIZE 4
DEF DOUBLE_SIZE 8
DEF EXTENDED_SIZE 10
DEF COMP_SIZE 8
DEF SIGNED_BYTE_SIZE 1
DEF SIGBYTE_SIZE 1
DEF SIGNED_WORD_SIZE 2
DEF SIGWORD_SIZE 2
DEF SIGNED_LONGWORD_SIZE 4
DEF SIGLONGWORD_SIZE 4

= vintage size consts
DEF DWORD_SIZE 4
DEF QWORD_SIZE 8


= data types
DEF CHAR_DATA 1
DEF BYTE_DATA 2
DEF WORD_DATA 3
DEF LONGWORD_DATA 4
DEF SIGNED_QWORD_DATA 5
DEF SIGQWORD_DATA 5
DEF TEXT_DATA 6
DEF FILE_DATA 7
DEF VARREF_DATA 8
DEF SINGLE_DATA 9
DEF DOUBLE_DATA 10
DEF EXTENDED_DATA 11
DEF COMP_DATA 12
DEF SIGNED_BYTE_DATA 13
DEF SIGBYTE_DATA 13
DEF SIGNED_WORD_DATA 14
DEF SIGWORD_DATA 14
DEF SIGNED_LONGWORD_DATA 15
DEF SIGLONGWORD_DATA 15

= vintage type consts
DEF DWORD_DATA 4
DEF QWORD_DATA 5


= fileseek constants
DEF FILE_BEGIN 0
DEF FILE_CURRENT 1
DEF FILE_END 2


= msgbox flags
DEF MB_OK 0
DEF MB_OKCANCEL 1
DEF MB_ABORTRETRYIGNORE 2
DEF MB_YESNOCANCEL 3
DEF MB_YESNO 4
DEF MB_RETRYCANCEL 5
DEF MB_CANCELTRYCONTINUE 6

DEF MB_ICONHAND 0x10
DEF MB_ICONQUESTION 0x20
DEF MB_ICONEXCLAMATION 0x30
DEF MB_ICONASTERISK 0x40
DEF MB_USERICON 0x80
DEF MB_ICONWARNING MB_ICONEXCLAMATION
DEF MB_ICONERROR MB_ICONHAND
DEF MB_ICONINFORMATION MB_ICONASTERISK
DEF MB_ICONSTOP MB_ICONHAND

DEF MB_DEFBUTTON1 0
DEF MB_DEFBUTTON2 0x0100
DEF MB_DEFBUTTON3 0x0200
DEF MB_DEFBUTTON4 0x0300

DEF MB_APPLMODAL 0
DEF MB_SYSTEMMODAL 0x1000
DEF MB_TASKMODAL 0x2000
DEF MB_HELP 0x4000

DEF MB_NOFOCUS 0x8000
DEF MB_SETFOREGROUND 0x00010000
DEF MB_DEFAULT_DESKTOP_ONLY 0x00020000

DEF MB_TOPMOST 0x00040000
DEF MB_RIGHT 0x00080000
DEF MB_RTLREADING 0x00100000

DEF MB_SERVICE_NOTIFICATION 0x00200000
DEF MB_SERVICE_NOTIFICATION_NT3X 0x00040000


= msgbox result
DEF IDOK 1          
DEF IDCANCEL 2      
DEF IDABORT 3       
DEF IDRETRY 4       
DEF IDIGNORE 5      
DEF IDYES 6         
DEF IDNO 7          
DEF IDCLOSE 8       
DEF IDHELP 9        
DEF IDTRYAGAIN 10
DEF IDCONTINUE 11


= shell command window state flags
DEF SW_HIDE 0
DEF SW_SHOWNORMAL 1
DEF SW_NORMAL 1
DEF SW_SHOWMINIMIZED 2
DEF SW_SHOWMAXIMIZED 3
DEF SW_MAXIMIZE 3
DEF SW_SHOWNOACTIVATE 4
DEF SW_SHOW 5
DEF SW_MINIMIZE 6
DEF SW_SHOWMINNOACTIVE 7
DEF SW_SHOWNA 8
DEF SW_RESTORE 9
DEF SW_SHOWDEFAULT 10


= error constants
= no error
DEF ERROR_NONE 0
= unknown error
DEF ERROR_UNKNOWN 1
= unassigned function handler (internal error)
DEF ERROR_HANDLER 2
= cannot write to the specified file
DEF ERROR_FILE_CANNOT_WRITE 3
= cannot read from the given file
DEF ERROR_FILE_CANNOT_READ 4
= cannot open file / file is not open
DEF ERROR_FILE_NOT_OPEN 5
= unknown property
DEF ERROR_PROPERTY 6
= invalid type (type mismatch error)
DEF ERROR_TYPE 7
= invalid (amount of) parameters to command/function
DEF ERROR_PARAMS 8
= readonly variable or function
DEF ERROR_VAR_READONLY 9
= invalid file mode
DEF ERROR_FILE_MODE 10
= floating point error
DEF ERROR_FLOAT 11
= unknown command
DEF ERROR_COMMAND 33
= commmand/func defined, but no code (internal error)
DEF ERROR_UNSUPPORTED 34
= stack over-/underflow
DEF ERROR_STACK 35
= error generated by user (ERROR cmd)
DEF ERROR_USER 36
= empty text value cannot be casted to another type
DEF ERROR_TEXTEMPTY 37
= cannot use special variable here
DEF ERROR_SPECIAL_VAR 38
= cannot delete file
DEF ERROR_FILE_CANNOT_DELETE 39
= error on external program execution
DEF ERROR_SHELL 41
= aborted by user (cancel button etc)
DEF ERROR_ABORT 42
= could not find spec. file
DEF ERROR_FILE_NOT_FOUND 65
= command is not available
DEF ERROR_DISABLED 66
= invalid external command
DEF ERROR_EXT_COMMAND 67
= browser file (cannot seek or read)
DEF ERROR_FILE_BROWSER 68
= no matching/current editor (window)
DEF ERROR_EDITOR 69
= directory not found
DEF DIR_NOT_FOUND 70

= text conversion flags
DEF TEXTCONVERT_ANSI 1
DEF TEXTCONVERT_DOS8 2
DEF TEXTCONVERT_ASCII7 3
DEF TEXTCONVERT_MAC 4
DEF TEXTCONVERT_EBCDIC 5
DEF TEXTCONVERT_UNICODELE 6
DEF TEXTCONVERT_UNICODE 6
DEF TEXTCONVERT_UNICODEBE 7
DEF TEXTCONVERT_CUSTOM 255



= functions for hexadecimal/decimal text conversion enabling
LOCAL HEX_TEXT_CONV
  NUMBER_RADIX=16
  NUMBER_PREFIX='0x'
  NUMBER_SUFFIX=''
  RETURN
ENDLOCAL

LOCAL DEC_TEXT_CONV
  NUMBER_RADIX=10
  NUMBER_PREFIX=''
  NUMBER_SUFFIX=''
  RETURN
ENDLOCAL

LOCAL OCT_TEXT_CONV
  NUMBER_RADIX=8
  NUMBER_PREFIX=''
  NUMBER_SUFFIX='o'
  RETURN
ENDLOCAL

